function SaveCoefs(ParameterFileReg,ParameterFileEst)

global NF NV corrc IDV

eval(ParameterFileReg);
eval(ParameterFileEst);

fhat=zeros(NF,1);
bhat=zeros(NV,1);
fsd=zeros(NF,1);
bsd=zeros(NV,1);

fhatA=zeros(NF,R);
bhatA=zeros(NV,R);
fsdA=zeros(NF,R);
bsdA=zeros(NV,R);

if corrc==0
    what=zeros(NV,1);
    wsd=zeros(NV,1);

    whatA=zeros(NV,R);
    wsdA=zeros(NV,R);
elseif corrc==1
    what=zeros(0.5*NV*(NV+1),1);
    wsd=zeros(0.5*NV*(NV+1),1);

    whatA=zeros(0.5*NV*(NV+1),R);
    wsdA=zeros(0.5*NV*(NV+1),R);
end

for i=1:R
    eval(['OutString=OutString',int2str(i),';']);
    eval(ParameterFileEst);
    
    load(CoefFile);

    if corrc==1
        [VCvec, VCSEvec]=randomcoefVCOVSE(what,ihess);

        fhatA(:,i)=fhat;
        bhatA(:,i)=bhat;
        whatA(:,i)=VCvec;

        fsdA(:,i)=fsd;
        bsdA(:,i)=bsd;
        wsdA(:,i)=VCSEvec;
    end
    if corrc==0
        fhatA(:,i)=fhat;
        bhatA(:,i)=bhat;
        whatA(:,i)=what;

        fsdA(:,i)=fsd;
        bsdA(:,i)=bsd;
        wsdA(:,i)=wsd;
    end
    
end

if corrc==0
    %m1,sd1,m2,sd2,...
    rhatA=zeros(2*NV,R);
    rsdA=zeros(2*NV,R);
    n=1;
    for i=1:NV
        rhatA(n,:)=bhatA(i,:);
        rsdA(n,:)=bsdA(i,:);
        n=n+1;
        rhatA(n,:)=whatA(i,:);
        rsdA(n,:)=wsdA(i,:);
        n=n+1;
    end
elseif corrc==1
    %m1,m2,m3,...,v1,c12,v2,c13,c23,v3,...
    rhatA=zeros(NV+0.5*NV*(NV+1),R);
    rsdA=zeros(NV+0.5*NV*(NV+1),R);

    rhatA(1:NV,:)=bhatA;
    rhatA(NV+1:NV+0.5*NV*(NV+1),:)=whatA;
    
    rsdA(1:NV,:)=bsdA;
    rsdA(NV+1:NV+0.5*NV*(NV+1),:)=wsdA;
end

coeff=[rhatA;fhatA];
se=[rsdA;fsdA];

data=[coeff se];
save(AllCoefOut,'data','-ascii','-double','-tabs');