function drawcoefficients(ParameterFileReg,ParameterFileEst,REPS,bootfolder)

eval(ParameterFileReg);
eval(ParameterFileEst);

for b=1:REPS 
   eval(['fhat',int2str(b),'=zeros(NF,R);']);
   eval(['bhat',int2str(b),'=zeros(NV,R);']);
   eval(['what',int2str(b),'=zeros(NV,R);']);
end
rng('default')

for i=1:R
 
 eval(['OutString=OutString',int2str(i),';']);
 eval(ParameterFileEst);   
 
 load(BootFile);
 
 rng(i); %Set seed of random number generator
 p=size(paramhat,1); %Number of estimated parameters
 ihess=inv(hessian); %vcov matrix
 phatd=repmat(paramhat',[REPS 1])+randn(REPS,p)*chol(ihess); %Draws 

 OutBoot=fullfile(OutDir,bootfolder);
 bootcoeffall=fullfile(OutBoot,[OutString,'_coefall.raw']);
 save(bootcoeffall,'phatd','-ascii','-double','-tabs');

 phatd=phatd'; %pxREPS


 for b=1:REPS 

  paramhats=phatd(:,b);    %px1
    
  if NF>0
    fh=paramhats(1:NF,1);    %NVX1 vector of fixed coeffs
  end
  
  if NV>0
    if sum(IDV(:,2) == 5) >0;
       bh=zeros(NV,1); %NVX1 vector to hold optimal b
       bh(IDV(:,2) ~= 5,1)=paramhats(NF+1:NF+sum(IDV(:,2) ~= 5),1);  %Error comp b equals 0
       wh=paramhats(NF+sum(IDV(:,2) ~= 5)+1:end,1); %NVX1 vector of optimal w
    else
       bh=paramhats(NF+1:NF+NV,1);
       wh=paramhats(NF+NV+1:NF+NV+NV,1);
    end;
  end
 eval(['bhat',int2str(b),'(:,i)=bh;']);
 eval(['what',int2str(b),'(:,i)=wh;']);
 eval(['fhat',int2str(b),'(:,i)=fh;']);
 end
end

eval(ParameterFileReg);

for b=1:REPS 
   bf=int2str(b);
   OutBoot=fullfile(OutDir,bootfolder,bf);
   mkdir(OutBoot);
   eval(['fhat=fhat',int2str(b),';']);
   eval(['bhat=bhat',int2str(b),';']);
   eval(['what=what',int2str(b),';']);
   
   bootcoeff=fullfile(OutBoot,[OutString,'_coef.mat']);
   
   save(bootcoeff,'fhat','bhat','what');
end
