function [W,w]=welfare_behave(AllCoefFile,X,XF,NP,NCSMAX,TALT,DR,MDR,S,R,Group,RC,NRC,ww) 

global NV NF NDRAWS NMEM NTAKES
global IDV IDF

[p, pp]=marketshare(AllCoefFile,X,XF,NP,NCSMAX,TALT,DR,MDR,R,Group,S); 
clear p
% pp is NAMxNCSMAXxNPxNDRAWS

%what=zeros(size(IDV,1),1);
load(AllCoefFile);

T=zeros(size(IDV,1),1);
for i=1:size(IDV,1)
    j=IDV(i,1);
    if sum(RC==j)
        T(i)=j; 
    end
end
V=IDV(:,1)==T;

T=zeros(size(IDF,1),1);
for i=1:size(IDF,1)
    j=IDF(i);
    if sum(NRC==j)
        T(i)=j; 
    end
end
VI=IDF==T;

NVc=sum(V);
NFc=sum(VI);

W=zeros(NCSMAX,NP); %NCSMAXxNP

for r=1:NTAKES   %NTAKES is the number of draws that are are read into memory at one time                              

if NTAKES>1
   DR=MDR.Data(1).drs((r-1).*NMEM+1:r.*NMEM,:,:); %Dimensions: NMEM x NP x NV
   DR=permute(DR,[3,2,1]); %To make NV x NP x NMEM
end

Group=repmat(Group,[1,1,1,NMEM]);

v=zeros(TALT,NCSMAX,NP,NMEM);
for i=1:R

 c=trans(bhat(:,i),what(:,i),DR,NP);   %c is NVxNPxNMEM matrix of b+w*dr (possibly transformed)

 if NFc > 0
    ff=reshape(fhat(VI,i),1,1,NFc,1);  %1x1xNFx1 matrix of fixed coeffs
    ff=repmat(ff,[TALT,NCSMAX,1,NP]); %NAMxNCSMxNFxNP matrix of fixed coeffs
    vf=reshape(sum(XF(:,:,VI,:).*ff,3),TALT,NCSMAX,NP);  %NAMxNCSMxNP matrix of f*FX
 else
    vf=zeros(TALT,NCSMAX,NP);
 end
 vf=repmat(vf,[1,1,1,NMEM]); %NAMxNCSMxNPxNMEM matrix of f*FX

 if NVc >0
   
    cc=reshape(c(V,:,:),1,1,NVc,NP,NMEM); %1x1xNVxNPxNMEM matrix of b+w*dr
    cc=repmat(cc,[TALT,NCSMAX,1,1,1]); %NAMxNCSMxNVxNPxNMEM matrix of b+w*dr
    vr=(repmat(X(:,:,V,:),[1,1,1,1,NMEM]).*cc); %NAMxNCSMxNVxNPxNMEM matrix of (b+w*dr).*RX
    vr=reshape(sum(vr,3),TALT,NCSMAX,NP,NMEM); %NAMxNCSMxNPxNMEM matrix of (b+w*dr)*RX
    v(Group==i)=vr(Group==i)+vf(Group==i); %NAMxNCSMxNPxNMEM matrix of f*FX+(b+w*dr)*RX
 else
    v(Group==i)=vf(Group==i);
 end

end

adj=sum(pp.*v,1); %1xNCSMAXxNPxNDRAWS
adj=reshape(adj,[NCSMAX NP NDRAWS]);

w=ww-adj;
sw=sum(w,3);                   %NCSMAXxNP 

W=W+sw;

if NTAKES>1
    eval(['w',int2str(r),'=w;']);
end

end

if NTAKES>1
    w=zeros(TALT,NCSMAX,NP,NDRAWS);
    for r=1:NTAKES
        eval(['w(:,:,:,1+(r-1)*NMEM:NMEM+(r-1)*NMEM)=w',int2str(r),';']);
    end
end
W=W./NDRAWS; %NCSMAXxNP 