function[DATA,NP,NCS,NROWS]=collapsedata(XMAT,run,Factor)

global IDV IDF NV NF
global IDWGT 
global dsm dcs alt mar 

market=XMAT(:,mar);
nMarket=max(market);

options=XMAT(:,alt);
TALT=max(options);

K=size(XMAT,2);

DATA=zeros(nMarket*TALT,K);
DATA(:,run)=XMAT(1,run);

for m=1:nMarket
     DATA(1+(m-1)*TALT:m*TALT,dcs)=m;
     DATA(1+(m-1)*TALT:m*TALT,dsm)=m;
     DATA(1+(m-1)*TALT:m*TALT,mar)=m;
     DATA(1+(m-1)*TALT:m*TALT,IDWGT)=sum(XMAT(market==m,IDWGT))./TALT;
         
     for j=1:TALT
          DATA(j+(m-1)*TALT,alt)=j;
          if NV>0
            DATA(j+(m-1)*TALT,IDV(:,1))=mean(XMAT(market==m & options==j,IDV(:,1)),1);
          end
          if NF>0
            DATA(j+(m-1)*TALT,IDF)=mean(XMAT(market==m & options==j,IDF),1);
          end
          if isempty(Factor)==0
              DATA(j+(m-1)*TALT,Factor)=mean(XMAT(market==m & options==j,Factor),1);
          end
     end
end      

NP=max(XMAT(:,mar));
NCS=max(XMAT(:,mar));
NROWS=size(DATA,1);