function [costs]=marginalcosts(Gradv,p,pp,TALT,Price,Market,nMarket,nFirms,AllFirmsProducts,WGT)

global S OFirm 

[GradS,GradM]=sharederiv(Gradv,pp,Market,TALT);

costs = zeros(TALT,nMarket);

findex=(1:nFirms)';

NO=length(OFirm);
for i=1:NO
    findex=findex(findex~=OFirm(i));
end

nInFirms=length(findex);

for ff=1:nInFirms
    
    f=findex(ff);
        
    CurrentProducts=AllFirmsProducts{f};
    NProd=size(CurrentProducts,1);      
        
    for m=1:nMarket
            
         Mindex=S;
         Mindex(Market~=m)=0;

         Mdsm=squeeze(max(max(Mindex,[],1),[],2));    %1xNP index of active dsm
         MWGT=WGT.*Mdsm';                             %1xNP market weights
            
         if NProd>1
             TempS=sum(squeeze(sum(Mindex(CurrentProducts,:,:).* ...
                 p(CurrentProducts,:,:),2)).*repmat(MWGT,[NProd 1]),2);   
             %NPROD x 1 matrix of summed probs
   
             GradMindex=GradM==m;
             TempD=sum(squeeze(sum(GradS(CurrentProducts,CurrentProducts,:,:).* ...
                 GradMindex(CurrentProducts,CurrentProducts,:,:),3)).* ...
                 permute(repmat(MWGT,[NProd,1,NProd]),[1 3 2]),3);  %NPROD x NPROD of summed dprob/dp
         elseif NProd==1
             TempS=sum(squeeze(sum(Mindex(CurrentProducts,:,:).* ...
                p(CurrentProducts,:,:),2))'.*MWGT);   
             %NPROD x 1 matrix of summed probs
            
             GradMindex=GradM==m;
             TempD=sum(squeeze(sum(GradS(CurrentProducts,CurrentProducts,:,:).* ...
                 GradMindex(CurrentProducts,CurrentProducts,:,:),3))'.*MWGT);  
             %NPROD x NPROD of summed dprob/dp
         end
   
         TempCost=Price(CurrentProducts,m) + TempD\TempS;
         %NPROD x NPROD matrix of costs.
            
         costs(CurrentProducts,m)=TempCost;  
    end
end
