function [VCvec, VCSEvec]=randomcoefVCOVSE(what,ihess)

global NF NV corrc IDV 

NVP=length(what);                 %Number of variance parameters
if sum(IDV(:,2) == 5) >0;
    Omega=ihess(NF+sum(IDV(:,2) ~= 5)+1:NF+sum(IDV(:,2) ~= 5)+NVP,NF+sum(IDV(:,2) ~= 5)+1:NF+sum(IDV(:,2) ~= 5)+NVP);   
else 
    Omega=ihess(NF+NV+1:NF+NV+NVP,NF+NV+1:NF+NV+NVP);   %NVPxNVP vcov(L)
end

if corrc==1
      L=zeros(NV,NV);             %Create NPxNP VC matrix
      x=0;
      for i=1:NV
           for j=1:i
             L(i,j)=what(x+1);
             x=x+1;
           end
      end
    VC=L*L';
    
    x=1;
    GradS=zeros(NV,NV,NVP);      %Create NVxNVxNVP matrix of derivative of LL'
    for i1=1:NV                  %(variance then covariance parametets)
        for i2=1:i1
           GradL=zeros(NV,NV);
           GradL(i1,i2)=1;
           GradS(:,:,x)=L*GradL'+GradL*L';
           x=x+1; 
        end
    end
    VCSE=zeros(NV,NV);          %Create NVxNV matrix of SE(VC)
    for i1=1:NV
        for i2=1:i1
            VCSE(i1,i2)=sqrt(squeeze(GradS(i1,i2,:))'*Omega*squeeze(GradS(i1,i2,:)));
            VCSE(i2,i1)=VCSE(i1,i2);
        end    
    end     
%     GradS=zeros(NV,NV,NVP);      %Create NVxNVxNVP matrix of derivative of LL'
%     for i1=1:NV                  %(variance then covariance parametets)
%       GradL=zeros(NV,NV);
%       GradL(i1,i1)=1;
%       GradS(:,:,i1)=L*GradL'+GradL*L';
%       GradL(i1,i1)=0;
%       for i2=1:i1-1
%          GradL(i1,i2)=1;
%          index=NV+(i1-1)*(i1-2)/2+i2;
%          GradS(:,:,index)=L*GradL'+GradL*L';
%          GradL(i1,i2)=0;
%       end
%     end
%     VCSE=zeros(NV,NV);          %Create NVxNV matrix of SE(VC)
%     for i1=1:NV
%         VCSE(i1,i1)=sqrt(squeeze(GradS(i1,i1,:))'*Omega*squeeze(GradS(i1,i1,:)));
%         for i2=1:i1-1
%           VCSE(i1,i2)=sqrt(squeeze(GradS(i1,i2,:))'*Omega*squeeze(GradS(i1,i2,:)));
%           VCSE(i2,i1)=VCSE(i1,i2);
%         end    
%     end
    VCvec=zeros(NV,1);          %Vectorise VC and SE(VC) (NVPx1)
    VCSEvec=zeros(NV,1);
    x=0;
    for i=1:NV
        for j=1:i
            VCvec(x+1)=VC(i,j);
            VCSEvec(x+1)=VCSE(i,j);
            x=x+1;
        end
    end
elseif corrc==0
    VCvec=zeros(NV,1);
    VCSEvec=zeros(NV,1);
    for i=1:NV
        VCvec(i)=what(i)^2;
        VCSEvec(i)=2*what(i)*sqrt(Omega(i,i));
    end
end
